/*
    In this example, use the assembly language listing for this
    program to notice how the two arrays x and y both keep data
    in the .data section. The automatic local array x needs to
    have its data copied onto the stack. So the array x uses
    storage space both on the stack and in the .data section!
*/
#include <stdio.h>
#ifdef __linux__
#include <unistd.h>   // sleep()
#elif _WIN32 || _WIN64
#include <windows.h>  // Sleep()
#endif

int main()
{
   int x[5] = {100, 101, 102, 103, 104};
   static int y[5] = {1000, 1001, 1002, 1003, 1004};

   printf("The address of the array x's data is %p\n",
            &(x[0]) );

   printf("The address of the array y's data is %p\n",
            &(y[0]) );

   // go into an infinite loop that does not use any processor resources
   while(1){
      #ifdef __linux__
         sleep(1);           // posix
      #elif _WIN32 || _WIN64
        Sleep(1000);         // windows
      #endif
   }

   return 0;
}
