/*
    This program finds out where the first location of the
    C runtime stack is located.
*/
#include <stdio.h>
#ifdef __linux__
#include <unistd.h>   // sleep()
#elif _WIN32 || _WIN64
#include <windows.h>  // Sleep()
#endif

int main()
{
   char x;
   printf("Location of stack (automatic) variable: %p\n", &x );

   // go into an infinite loop that does not use any processor resources
   while(1){
      #ifdef __linux__
         sleep(1);           // posix
      #elif _WIN32 || _WIN64
        Sleep(1000);         // windows
      #endif
   }

   return 0;
}
