/** smsh2.c - small-shell version 2
 **		small shell that supports command line parsing
 **		and if..then..else.fi logic (by calling process())
 **/
#include	<stdio.h>
#include	<stdlib.h>
#include	<signal.h>
#include	"splitline.h"
#include	"execute.h"
#include	"process.h"

#define	DFL_PROMPT	"> "

/*
 * purpose: initialize shell
 * returns: nothing. calls fatal() if trouble
 */
void setup()
{
	signal(SIGINT,  SIG_IGN);
	signal(SIGQUIT, SIG_IGN);
}


int main()
{
	char	*cmdline, *prompt, **arglist;
	int	result;

	setup();
	prompt = DFL_PROMPT ;

	while ( (cmdline = next_cmd(prompt, stdin)) != NULL ){
		if ( (arglist = splitline(cmdline)) != NULL ){
			result = process(arglist);
			freelist(arglist);
		}
		free(cmdline);
	}
	return 0;
}
