/**
 **	small-shell version 4
 **		first really useful version after prompting shell
 **		this one parses the command line into strings
 **		uses fork, exec, wait, and ignores signals
 **/
#include	<stdio.h>
#include	<stdlib.h>
#include	<signal.h>
#include	<sys/wait.h>
#include	"splitline.h"
#include	"execute.h"
#include	"process.h"
#include	"varlib.h"

#define	DFL_PROMPT	"> "

/*
 * purpose: initialize shell
 * returns: nothing. calls fatal() if trouble
 */
void setup()
{
	extern char **environ;

	VLenviron2table(environ);
	signal(SIGINT,  SIG_IGN);
	signal(SIGQUIT, SIG_IGN);
}


int main()
{
	char	*cmdline, *prompt, **arglist;
	int	result;

	setup();
	prompt = DFL_PROMPT ;

	while ( (cmdline = next_cmd(prompt, stdin)) != NULL ){
		if ( (arglist = splitline(cmdline)) != NULL ){
			result = process(arglist);
			freelist(arglist);
		}
		free(cmdline);
	}
	return 0;
}
