/*
   IMPORTANT: Try compiling this example using the
              online compiler and disassembler at:

              http://gcc.godbolt.org


DS   f(...);         // DS automatically allocated in caller's local space

     f(DS x, ...);   // DS automatically allocated in callee's local space
*/
#include <stdio.h>
#include <stdlib.h>


typedef struct DS {
   int a;
   double b;
   char c;
} DS;


DS f5()  /* DS automatically allocated in caller's local space */
{
   DS x;
   x.a = 5;
   return x;
}


void f6(DS x)  /* DS automatically allocated in callee's local space */
{
   printf("in f6(), x.a = %d\n", x.a);
}


int main()
{
   DS ds5 = f5(); /* return value from f5() is copied into ds5 */
   printf("in main(), ds5.a = %d\n", ds5.a);

   DS ds6;
   ds6.a = 6;
   f6(ds6); /* ds6 is copied into f6's actual parameter */

   return 0;
}
